package guestbook.beans;

import java.sql.*;
import java.io.*;
import java.util.*;

import guestbook.beans.GuestBookBean;

public class GuestBookManager {

	private static GuestBookManager instance = new GuestBookManager();
    
    public static GuestBookManager getInstance() {
        return instance;
    }
    
    private GuestBookManager() {}
    
    public void insert(GuestBookBean book) throws Exception {
        Connection conn;
        PreparedStatement pstmt = null;
        
        try{
			Class.forName("com.mysql.jdbc.Driver");
		}catch (ClassNotFoundException e){
			System.out.println("jdbc");
		}
		
        try {
        	String url = "";
			conn = DriverManager.getConnection(url, "", "");
            pstmt = conn.prepareStatement("insert into GUESTBOOK (REGISTER,NAME,EMAIL,PASSWORD,CONTENT) "+
            								"values (?,?,?,?,?)");
            
            pstmt.setTimestamp(1, book.getRegister());
            pstmt.setString(2, book.getName());
            pstmt.setString(3, book.getEmail());
            pstmt.setString(4, book.getPassword());
            pstmt.setCharacterStream(5, new StringReader(book.getContent()), book.getContent().length());
            
            pstmt.executeUpdate();
        } catch(SQLException ex) {
            throw new Exception("insert", ex);
        }
        if (pstmt != null) try { pstmt.close(); } catch(SQLException ex) {}
        if (conn != null) try { conn.close(); } catch(SQLException ex) {}
    }
    
    public List<GuestBookBean> getList() throws Exception {
        Connection conn = null;
        PreparedStatement pstmt = null;
        ResultSet rs = null;
        
        try{
			Class.forName("com.mysql.jdbc.Driver");
		}catch (ClassNotFoundException e){
			System.out.println("jdbc");
		}
		
        try {
        	String url = "";
			conn = DriverManager.getConnection(url, "", "");
            pstmt = conn.prepareStatement(
            "select * from GUESTBOOK order by GUESTBOOK_ID desc");
            rs = pstmt.executeQuery();
            
            List<GuestBookBean> list = new java.util.ArrayList<GuestBookBean>();
            while (rs.next()) {
            	GuestBookBean book = new GuestBookBean();
                book.setId(rs.getInt("GUESTBOOK_ID"));
                book.setRegister(rs.getTimestamp("REGISTER"));
                book.setName(rs.getString("NAME"));
                book.setEmail(rs.getString("EMAIL"));
                book.setPassword(rs.getString("PASSWORD"));
                Reader reader = null;
                try {
                    reader = rs.getCharacterStream("CONTENT");
                    char[] buff = new char[512];
                    int len = -1;
                    StringBuffer buffer = new StringBuffer(512);
                    while( (len = reader.read(buff)) != -1) {
                        buffer.append(buff, 0, len);
                    }
                    book.setContent(buffer.toString());
	            } catch(IOException iex) {
	            	throw new Exception("getList", iex);
	            } finally {
	            	if (reader != null) try { reader.close(); } catch(IOException iex) {}
	            }
                list.add(book);
            }
            return list;
        } catch(SQLException ex) {
            throw new Exception("getList", ex);
        } finally {
            if (rs != null) try { rs.close(); } catch(SQLException ex) {}
            if (pstmt != null) try { pstmt.close(); } catch(SQLException ex) {}
            if (conn != null) try { conn.close(); } catch(SQLException ex) {}
        }
    }
}
